﻿/*
  Autor: Wojciech Domski
  Email: y0yster@o2.pl
  lub
  Email: Wojciech.Domski@gmail.com

  Strona
             Domski.pl
             Wojciech.Domski.pl

  copyright 2014 Wojciech Domski

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Niniejszy program jest wolnym oprogramowaniem; możesz go
    rozprowadzać dalej i/lub modyfikować na warunkach Powszechnej
    Licencji Publicznej GNU, wydanej przez Fundację Wolnego
    Oprogramowania - według wersji 2 tej Licencji lub (według twojego
    wyboru) którejś z późniejszych wersji.

    Niniejszy program rozpowszechniany jest z nadzieją, iż będzie on
    użyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domyślnej
    gwarancji PRZYDATNOŚCI HANDLOWEJ albo PRZYDATNOŚCI DO OKREŚLONYCH
    ZASTOSOWAŃ. W celu uzyskania bliższych informacji sięgnij do
    Powszechnej Licencji Publicznej GNU.

    Z pewnością wraz z niniejszym programem otrzymałeś też egzemplarz
    Powszechnej Licencji Publicznej GNU (GNU General Public License);
    jeśli nie - napisz do Free Software Foundation, Inc., 59 Temple
    Place, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include "MAX7221.h"

#include <SPI.h>

const int slaveSelect = 10;

void sendCommand( int command, int value)
{
	digitalWrite(slaveSelect,LOW);
	SPI.transfer(command);
	SPI.transfer(value);
	digitalWrite(slaveSelect,HIGH);
}

void clearRest( int col, int row)
{
	for( int i = col; i < 4; ++i)
	{
		sendCommand(4-i+row*4, 0x0F);
	}
}

void initMAX7221( void)
{
	SPI.begin();
	pinMode(slaveSelect, OUTPUT);
	// prepare the 7221 to display 7-segment data - see data sheet
	sendCommand(12,1); //normal mode
	sendCommand(15,0); //display test off
	sendCommand(10,0); //set minimal brightness
	sendCommand(11,7); //scan all 8 digits
	sendCommand(9,255); //number decoding for all digits
	
	//set all to 0
	for( int i = 1; i < 9; ++i)
	sendCommand( i, 0x0F);
}













