/*
* SimpleDualThermometer.ino
*
* Created: 12/23/2014 3:31:23 PM
* Author: Wojciech Domski
*/

#include <SPI.h>

#include "filter.h"
#include "TimerOne.h"

#include "MAX7221.h"
#include "light.h"
#include "temerature.h"

void setup()
{		
	Serial.begin(115200);
	
	initTemp();
	initLight();
	
	initMAX7221();	

	delay(750);
	
	Timer1.initialize(1000000);	//initialize timer for 1 second
	Timer1.attachInterrupt(DoWork); //attach software interrupt	
}

void loop()
{
	//make it idle
	delay(100);
}

void DoWork()
{
	readTemp();
	
	readLight();
	
	showTemp();
}

