﻿/*
  Autor: Wojciech Domski
  Email: y0yster@o2.pl
  lub
  Email: Wojciech.Domski@gmail.com

  Strona
             Domski.pl
             Wojciech.Domski.pl

  copyright 2012 Wojciech Domski

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Niniejszy program jest wolnym oprogramowaniem; możesz go
    rozprowadzać dalej i/lub modyfikować na warunkach Powszechnej
    Licencji Publicznej GNU, wydanej przez Fundację Wolnego
    Oprogramowania - według wersji 2 tej Licencji lub (według twojego
    wyboru) którejś z późniejszych wersji.

    Niniejszy program rozpowszechniany jest z nadzieją, iż będzie on
    użyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domyślnej
    gwarancji PRZYDATNOŚCI HANDLOWEJ albo PRZYDATNOŚCI DO OKREŚLONYCH
    ZASTOSOWAŃ. W celu uzyskania bliższych informacji sięgnij do
    Powszechnej Licencji Publicznej GNU.

    Z pewnością wraz z niniejszym programem otrzymałeś też egzemplarz
    Powszechnej Licencji Publicznej GNU (GNU General Public License);
    jeśli nie - napisz do Free Software Foundation, Inc., 59 Temple
    Place, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include "filter.h"


/**
 * y[n] = a_0 x[n] + a_1 x[n-1] + a_2 x[n-2] +
 *
 *      b_1 y[n-1] + b_2 y[n-2] + b_3 y[n-3]
 */

void SinglePoleLowPassInit( float x, tSinglePoleCoeff * coeff)
{
  coeff->a[0] = 1.0 - x;
  coeff->b[1] = x;

  int i;
  coeff->row = 2;

  for( i = 0; i < coeff->row; ++i)
  {
    coeff->x[i] = 0.0;
    coeff->y[i] = 0.0;
  }
}

void SinglePoleLowPassInitAll( float x, float y, tSinglePoleCoeff * coeff)
{
	coeff->a[0] = 1.0 - x;
	coeff->b[1] = x;

	int i;
	coeff->row = 2;

	for( i = 0; i < coeff->row; ++i)
	{
		coeff->x[i] = y;
		coeff->y[i] = y;
	}
}

float SinglePoleLowPass( float value, tSinglePoleCoeff * coeff)
{
  int i;
  
  //move x
  for( i = coeff->row - 1; i > 0; --i)
    coeff->x[i] = coeff->x[i-1];

  coeff->x[0] = value;

  coeff->y[0] = 0.0;

  for( i = 0; i < coeff->row; ++i)
  {
    coeff->y[0] += coeff->a[i] * coeff->x[i];

    if( i >= 1)
      coeff->y[0] += coeff->b[i] * coeff->y[i];
  }

  for( i = coeff->row - 1; i > 0; --i)
    coeff->y[i] = coeff->y[i-1];

  return coeff->y[0];
}

void SinglePoleHighPassInit( float x, tSinglePoleCoeff * coeff)
{
  coeff->a[0] = (1.0 + x) / 2.0;
  coeff->a[1] = - (1.0 + x) / 2.0;
  coeff->b[1] = x;
}

float SinglePoleHighPass( float value, tSinglePoleCoeff * coeff)
{

  return 0.0;
}



















