﻿/*
  Autor: Wojciech Domski
  Email: y0yster@o2.pl
  lub
  Email: Wojciech.Domski@gmail.com

  Strona
             Domski.pl
             Wojciech.Domski.pl

  copyright 2014 Wojciech Domski

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Niniejszy program jest wolnym oprogramowaniem; możesz go
    rozprowadzać dalej i/lub modyfikować na warunkach Powszechnej
    Licencji Publicznej GNU, wydanej przez Fundację Wolnego
    Oprogramowania - według wersji 2 tej Licencji lub (według twojego
    wyboru) którejś z późniejszych wersji.

    Niniejszy program rozpowszechniany jest z nadzieją, iż będzie on
    użyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domyślnej
    gwarancji PRZYDATNOŚCI HANDLOWEJ albo PRZYDATNOŚCI DO OKREŚLONYCH
    ZASTOSOWAŃ. W celu uzyskania bliższych informacji sięgnij do
    Powszechnej Licencji Publicznej GNU.

    Z pewnością wraz z niniejszym programem otrzymałeś też egzemplarz
    Powszechnej Licencji Publicznej GNU (GNU General Public License);
    jeśli nie - napisz do Free Software Foundation, Inc., 59 Temple
    Place, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include <arduino.h>
#include "light.h"
#include "filter.h"
#include "MAX7221.h"

tSinglePoleCoeff backlight_coeff;

void readLight( void)
{
	int lightValue;
	String str;
	
	lightValue = SinglePoleLowPass( getLight(), &backlight_coeff);
	str = String( lightValue);
	Serial.print("A = ");
	Serial.println(str.c_str());
	sendCommand(10, limitLight( lightValue));
}

int limitLight(int light)
{
	if( light > LIGHT_MAX)
	light = LIGHT_MAX;
	if( light < LIGHT_MIN)
	light = LIGHT_MIN;
	
	return map( light, LIGHT_MIN, LIGHT_MAX, 0, 15);
}

int getLight( void)
{
	return analogRead(0);
}
void initLight( void)
{
	SinglePoleLowPassInitAll( 0.790, (float)getLight(), &backlight_coeff);
}















